﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BitmapDataChannel;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.filters.BlurFilter;
	import flash.filters.ConvolutionFilter;
	import flash.filters.ColorMatrixFilter;
	
	import flash.media.Video;
	import flash.media.Camera;
	import flash.display.DisplayObject;
	
	public class Liaer extends Sprite
	{
		private var background:Sprite = new Sprite();
		private var bmd:BitmapData;
		private var maskBMP:Bitmap = new Bitmap();
		
		private var filterObj:BlurFilter = new BlurFilter(2,2,3);//permet de faire disparaître particules
		private var canevas:Sprite = new Sprite();
		private var circles:Array;
		
		private var myPicture:BitmapData;
		private var video:Video = new Video(600,600);
		
		private var colors:Array = ['0x000000','0xffffff'];
		
		
		/*
		http://blog.mattiasnorell.com/2010/04/16/dynamic-as3-mask-using-bitmapdata/ --> pour utiliser un bitmap comme masque
		http://www.sylvainmeltz.com/wordpress/2011/12/as3-video-camera/ --> pour utiliser la camera
		*/
		public function Liaer()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function fullhandler(e:FullScreenEvent):void
		{
			setup();
		}
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			setup();
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function setup():void
		{
			bmd = new BitmapData(stage.stageWidth,stage.stageHeight,true,0);
			
			myPicture = new BitmapData(stage.stageWidth,stage.stageHeight,false,0);
			video.attachCamera( Camera.getCamera() );
			
			background.addChild(new Bitmap(myPicture));
			addChild(background);
			
			addChild(maskBMP);
			background.mask = maskBMP;
			
			buildModels(10);
		}
		private function buildModels(val:uint):void
		{
			circles = [];
			for(var i:uint = 0;i<val;i++){
				circles.push({'r':(Math.random()*10 + 2),'max':(Math.random()*50 + 50),'centerX':(Math.random()*300)+150,'centerY':(Math.random()*300)+150,'angle':Math.random()*360,'dec':Math.random()*360,'color':colors[Math.round(Math.random()*(colors.length-1))]});
			}
		}
		private function enterHandler(e:Event):void
		{
			myPicture.draw (video);
			for(var j:uint = 0;j<circles.length;j++){
				canevas.graphics.clear();
				for(var i:uint = 0;i<360;i++){
					if (circles[j].r < circles[j].max) circles[j].r+=0.001; else circles[j].r = (Math.random()*10 + 2);
					canevas.graphics.lineStyle(2,circles[j].color,i/10);
					(i==0)?canevas.graphics.moveTo(Math.cos((i+circles[j].dec)*Math.PI/180)*circles[j].r + circles[j].centerX,Math.sin((i+circles[j].dec)*Math.PI/180)*circles[j].r + circles[j].centerY):canevas.graphics.lineTo(Math.cos((i+circles[j].dec)*Math.PI/180)*circles[j].r + circles[j].centerX,Math.sin((i+circles[j].dec)*Math.PI/180)*circles[j].r+ circles[j].centerY);
				}
				bmd.draw(canevas);
				if (circles[j].centerX > stage.stageWidth || circles[j].centerX<0) circles[j].centerX = Math.random()*300+150;
				if (circles[j].centerY > stage.stageHeight || circles[j].centerY<0) circles[j].centerY = Math.random()*300+150;
				circles[j].centerX+=Math.cos(circles[j].angle*Math.PI/180)*Math.random()*2;
				circles[j].centerY+=Math.sin(circles[j].angle*Math.PI/180)*Math.random()*2;
				circles[j].dec+=Math.cos(circles[j].angle);
			}
			bmd.applyFilter(bmd,bmd.rect,new Point(0,0),filterObj);
			
            maskBMP.bitmapData = bmd;
			
            background.cacheAsBitmap = true;
            maskBMP.cacheAsBitmap = true;
		}
	}
}